#include <stdafx.h>

#include "FontPreviewDlg.h"
#include "..//Resource.h"

static  char comment[100];

static short  hText = 0;

SG_POINT  gab[2];
RECT      draw_rect;
HDC       draw_DC = NULL;

BOOL NEAR CALLBACK HandleNotify(HWND , LPOFNOTIFY);

static void RefillFontPic(HWND hDlg);
static void FPDrawItem(HWND hDlg, LPDRAWITEMSTRUCT lpdis);


DWORD GetTextExtent(HDC hDC, LPCSTR s, int len)
{
	SIZE dim;
	DWORD dw;
	GetTextExtentPoint32(hDC, s, len, &dim);
	dw = ((dim.cy << 16) & 0xFFFF0000)| dim.cx;
	return dw;
}

//Hook function for the Comm Dlg
LRESULT CALLBACK ComDlgPreviewProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
//int		              wtext, wlist, hlist, hctl, zbut, xnc, ync;
LPDRAWITEMSTRUCT		lpdis;
LPMEASUREITEMSTRUCT lpmis;
HDC                 hDC;

	switch (uMsg)
	{
	case WM_INITDIALOG:
		// Save off the long pointer to the OPENFILENAME structure.
		SetWindowLong(hDlg, DWL_USER, lParam);
		break;
	case WM_CTLCOLORLISTBOX:
		return (LRESULT)GetStockObject(GRAY_BRUSH);
	case WM_DESTROY:
		{
			LPOPENFILENAME lpOFN = (LPOPENFILENAME)GetWindowLong(hDlg, DWL_USER);
		}
		break;
	case WM_COMMAND:
		break;
	case WM_NOTIFY:
		//Handles Notify messages
		HandleNotify(hDlg, (LPOFNOTIFY)lParam);
	case WM_DRAWITEM:
		lpdis = (LPDRAWITEMSTRUCT)lParam;
		hText = HIWORD(GetTextExtent(lpdis->hDC, "9",1));
		//if(lpdis->itemAction & ODA_DRAWENTIRE){
			FPDrawItem(hDlg, lpdis);
			return TRUE;
		/*}
		else if(lpdis->itemAction & ODA_SELECT){
			FPSelectionItem(hDlg, lpdis);
			return TRUE;
		}*/
		return TRUE;
	case WM_MEASUREITEM:
		hDC = GetDC(hDlg);
		lpmis = (LPMEASUREITEMSTRUCT)lParam;
		lpmis->itemHeight = LOWORD(GetTextExtent(hDC, "9",1))*4 + 13;
		lpmis->itemWidth  = LOWORD(GetTextExtent(hDC, "9",1))*4 + 13;
		ReleaseDC(hDlg, hDC);
	default:
		return FALSE;
	}
	return TRUE;
}


//Call back to handle notify messages
BOOL NEAR CALLBACK HandleNotify(HWND hDlg, LPOFNOTIFY pofn)
{
	switch (pofn->hdr.code)
	{
		// The selection has changed. 
	case CDN_SELCHANGE:
		{
			/*
				Only in register version
			*/
		}
		break;
	case CDN_FILEOK:
		//return FALSE to close the Comm Dlg
		return FALSE;
		break;
	}
	return(TRUE);
}
//Shows the Comm Dialog
BOOL ShowOpenFontDialogPreview(HWND hWnd,TCHAR * szFile)
{

	/*
	Only in register version
	*/
	return TRUE;
}

static void RefillFontPic(HWND hDlg)
{
	/*
	Only in register version
	*/
}


void draw_for_gabar_calc(SG_POINT* pb,SG_POINT* pe)
{
	if (pb->x < gab[0].x) gab[0].x = pb->x;
	if (pb->y < gab[0].y) gab[0].y = pb->y;
	if (pb->z < gab[0].z) gab[0].z = pb->z;
	if (pb->x > gab[1].x) gab[1].x = pb->x;
	if (pb->y > gab[1].y) gab[1].y = pb->y;
	if (pb->z > gab[1].z) gab[1].z = pb->z;

	if (pe->x < gab[0].x) gab[0].x = pe->x;
	if (pe->y < gab[0].y) gab[0].y = pe->y;
	if (pe->z < gab[0].z) gab[0].z = pe->z;
	if (pe->x > gab[1].x) gab[1].x = pe->x;
	if (pe->y > gab[1].y) gab[1].y = pe->y;
	if (pe->z > gab[1].z) gab[1].z = pe->z;
}

void draw_for_draw(SG_POINT* pb,SG_POINT* pe)
{
	double scX = (draw_rect.right-draw_rect.left)/(gab[1].x-gab[0].x);
	double scY = (draw_rect.bottom-draw_rect.top)/(gab[1].y-gab[0].y);
	MoveToEx(draw_DC, (int)(draw_rect.left+(pb->x-gab[0].x)*scX), 
		(int)(draw_rect.bottom-(pb->y-gab[0].y)*scY),NULL);
	LineTo(draw_DC, (int)(draw_rect.left+(pe->x-gab[0].x)*scX), 
		(int)(draw_rect.bottom-(pe->y-gab[0].y)*scY));
}

//#pragma argsused
static void FPDrawItem(HWND hDlg, LPDRAWITEMSTRUCT lpdis)
{
	/*
	Only in register version
	*/
}



